var backWidth = 220;
var backHeight = 290;
var frontWidth = 190;
var frontHeight = 190;
var extraWidth = 20;
var extraHeight = 20;
var backShown = false;
var gadget = new Object();

function setup() {
  if (window.widget) {
    widgetSetup();
    readPrefs();
    parse();
    updateParams();
    fillBackside();
    document.getElementById("Property_src").onchange = setSrc;
    var style1 = 
      document.defaultView.getComputedStyle(document.getElementById("Gadgets"), "");
    var style2 = 
      document.defaultView.getComputedStyle(document.getElementById("Background"), "");
    extraWidth = parseInt(style2.width) - parseInt(style1.width);  
    extraHeight = parseInt(style2.height) - parseInt(style1.height);  
    var style3 = 
      document.defaultView.getComputedStyle(document.getElementById("Backside"), "");
    if (style3 != null) {
      backWidth = parseInt(style3.width);  
      backHeight = parseInt(style3.height);
    }          
    widget.onshow = apply;
    widget.onremove = clearPrefs;
    var refresh = document.getElementById("Refresh");
    if (refresh != null) {
      refresh.onclick = apply;
    }  
    if (widget.context != null) {
      var link = document.getElementById("WidgetopUrl");
      if (link != null) {
        link.style.display = "none";
      }
    }
  }  
}

function readPrefs() {
  var value = widget.preferenceForKey(widget.identifier + "-src");
  if (value != null) {
    gadget.src = value;
  }
  else {
    gadget.src = "http://gmodules.com/ig/ifr?url=http://www.google.com/ig/modules/googlevideo.xml&amp;synd=open&w=320&h=280&title=__MSG_title__&lang=all&country=ALL&border=%23ffffff%7C3px%2C1px+solid+%23999999&output=js";
  }
}

function clearPrefs() {
  widget.setPreferenceForKey(null, widget.identifier + "-src");
}
    
function fillBackside() {
  for (var key in gadget) {
  	var element =  document.getElementById("Property_" + key);
  	if (element != null) {
  	  element.value = gadget[key];
  	} 
  }
}

function applyBackside() {
  for (var key in gadget) {
  	var element =  document.getElementById("Property_" + key);
  	if (element != null) {
  	  if (key == "width" || key == "height") {
  	    gadget[key] = parseInt(element.value);
  	  }
  	  else {  
  	    gadget[key] = element.value;
  	  }  
  	} 
  }
  parse();
  apply();  
  widget.setPreferenceForKey(gadget.src, widget.identifier + "-src");
}

function setSrc() {
  var src = document.getElementById("Property_src").value;
  widget.setPreferenceForKey(src, widget.identifier + "-src");
  gadget.src = src;
  gadget.width = null;
  gadget.height = null;
  gadget.title = null;
  gadget.border = null;
  parse();
  fillBackside();
}

function parse() {
  var spaceWidth = 30;
  var spaceHeight = 70;
  if (gadget.title == null) {
    gadget.title = getParameter("title");
  }
  else {
    setParameter("title", gadget.title);
  }
  if (gadget.hideTitle) {
    setParameter("title", "");    
  }
  if (getParameter("title").length == 0) {
    spaceHeight = 55;
  }
  if (gadget.border != null) {
    setParameter("border", gadget.border);
  }
  else {
    gadget.border = getParameter("border");
  }
  if (gadget.width) {
    setParameter("w", gadget.width - spaceWidth);
  }
  else {
    gadget.width = parseInt(getParameter("w", frontWidth)) + spaceWidth;
  }
  if (gadget.height) {
    setParameter("h", gadget.height - spaceHeight);
  }
  else {
    gadget.height = parseInt(getParameter("h", frontHeight)) + spaceHeight;
  }
}

function getParameter(key, defaultValue) {
  var src = gadget.src;
  if (src.indexOf("&amp;") >= 0) {
    src = src.replace(/\&amp\;/g, "&");
  }
  var index = src.indexOf("&" + key + "=");
  if (index < 0) {
    index = src.indexOf("?" + key + "=");
  }
  if (index > 0) {
    var index2 = src.indexOf("&", index + 1);
    if (index2 >= 0) {
      return decode(src.substring(index + key.length + 2, index2));
    }
    return decode(src.substring(index + key.length + 2));
  }
  return defaultValue;   
}

function decode(value) {
  var result = decodeURIComponent(value);
  return result.replace(/(\+)/g, " ");
}

function encode(value) {
  var result = encodeURIComponent(value);
  return result.replace(/(\s)/g, "+");  
}

function setParameter(key, value) {
  var src = gadget.src;
  if (src.indexOf("&amp;") >= 0) {
    src = src.replace(/\&amp\;/g, "&");
  }
  var index = src.indexOf(key + "=");
  if (index > 0) {
    var index2 = src.indexOf("&", index);
    if (index2 < 0) {
      index2 = src.length;
    }
    gadget.src = src.substring(0, index + key.length + 1) + encode(value) + src.substring(index2);    
  }
}

function apply() {
  document.getElementById("Loading").style.display = "block";
  var element = document.getElementById("Gadget");
  var src = gadget.src;
  if (src.indexOf("&amp;") >= 0) {
    src = src.replace(/\&amp\;/g, "&");
  }
  element.gadgetSrc = src;
  element.onload = loaded;
  element.onerror = function() {
    alert("Loading inner.html failed.");
  }
  
  var date = new Date();
  element.src = "inner.html?" + date.getTime();
  element.width = gadget.width;
  element.height = gadget.height;
  frontWidth = gadget.width + extraWidth;
  frontHeight = gadget.height + extraHeight;
  if (!backShown) {
    window.resizeTo(frontWidth, frontHeight);
  }
}

function loaded() {
  var element = this;
  var script = frames["Gadget"].document.getElementById("Code");
  if (script != null) {
    script.parentNode.removeChild(script);
  }
  script = frames["Gadget"].document.createElement("script");
  script.id = "Code";
  script.setAttribute("type", "text/javascript");
  script.setAttribute("src", element.gadgetSrc);
  frames["Gadget"].document.getElementsByTagName("head")[0].appendChild(script);
  document.getElementById("Loading").style.display = "none";
}

function updateParams() {
  var params = gadget.params;
  if (params != null && params.length > 0) { 
    for (var i = 0; i < params.length; i++) {
      var element = document.getElementById("Parameter_" + params[i]);
      if (element && element.value != null) {
        setParameter("up_" + params[i], element.value);
      }
    }
  }
}

function showHelp() {
  document.getElementById("Help").style.display = "block";
}

function closeHelp() {
  document.getElementById("Help").style.display = "none";  
}

function widgetSetup() {
  if (window.widget) {
  	var gDoneButton = new AppleGlassButton(document.getElementById("HelpButton"), 
  	                                      "Help", showHelp); 
  	var gDoneButton = new AppleGlassButton(document.getElementById("DoneButton"), 
  	                                      "Done", hideBack); 
	  var gInfoButton = new AppleInfoButton(document.getElementById("InfoButton"), 
	                                        document.getElementById("front"), 
	                                        "black", "black", showBack);
  }
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if(window.widget)
        widget.prepareForTransition("ToBack");
 
    backShown = true;
    front.style.display="none";
    frontWidth = window.innerWidth;
    frontHeight = window.innerHeight;
    window.resizeTo(backWidth, backHeight);
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    backShown = false;
    back.style.display="none";
    window.resizeTo(frontWidth, frontHeight);  
    if (gadget.params != null && params.length > 0) {
      updateParams();
      apply();
    }
    applyBackside();
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}                                                
  